# coding: utf-8

"""
    Freestyle Sandboxes

     Freestyle Sandboxes lets you deploy your users or AIs code. **Get your API Key at [admin.freestyle.sh](https://admin.freestyle.sh)**  They are broken up into core 5 categories: [Web](#tag/web), [Execute](#tag/execute), [Cloudstate](#tag/cloudstate), [Git](#tag/git), and [Domains](#tag/domains).  [Web](#tag/web): Send us the code for the website, we'll provision the certificates and get it hosted  [Execute](#tag/execute): Send us a function, we'll run it and send you the output  [Cloudstate](#tag/cloudstate): Our Opensource JavaScript Runtime used for cloud functions with persistent state  [Domains](#tag/domains): Manage your domains, including verification and listing  [Git](#tag/git): Manage your git repositories 

    The version of the OpenAPI document: 0.1.0
    Contact: ben@freestyle.sh
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List
from _openapi_client.models.branch_details import BranchDetails
from _openapi_client.models.tag_details import TagDetails
from typing import Optional, Set
from typing_extensions import Self

class RepositoryMetadata(BaseModel):
    """
    RepositoryMetadata
    """ # noqa: E501
    branches: Dict[str, BranchDetails]
    tags: Dict[str, TagDetails]
    default_branch: StrictStr = Field(alias="defaultBranch")
    __properties: ClassVar[List[str]] = ["branches", "tags", "defaultBranch"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RepositoryMetadata from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in branches (dict)
        _field_dict = {}
        if self.branches:
            for _key_branches in self.branches:
                if self.branches[_key_branches]:
                    _field_dict[_key_branches] = self.branches[_key_branches].to_dict()
            _dict['branches'] = _field_dict
        # override the default output from pydantic by calling `to_dict()` of each value in tags (dict)
        _field_dict = {}
        if self.tags:
            for _key_tags in self.tags:
                if self.tags[_key_tags]:
                    _field_dict[_key_tags] = self.tags[_key_tags].to_dict()
            _dict['tags'] = _field_dict
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RepositoryMetadata from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "branches": dict(
                (_k, BranchDetails.from_dict(_v))
                for _k, _v in obj["branches"].items()
            )
            if obj.get("branches") is not None
            else None,
            "tags": dict(
                (_k, TagDetails.from_dict(_v))
                for _k, _v in obj["tags"].items()
            )
            if obj.get("tags") is not None
            else None,
            "defaultBranch": obj.get("defaultBranch")
        })
        return _obj


